/*
 *
 */

#include <afs/param.h>	/* Should be always first */
#ifdef	AFS_NETBSD_ENV
#include <afs/sysincludes.h>		/* Standard vendor system headers */
#include <afs/afsincludes.h>		/* Afs-based standard headers */
#include <afs/afs_stats.h>		/* statistics */
#include <sys/malloc.h>
#include <sys/conf.h>
#include <sys/exec.h>
#include <sys/lkm.h>
#include <ufs/ffs/ffs_extern.h>

int afs_syscall_iopen(dev_t dev, unsigned long ino, long mode);

int afs_syscall_icreate(dev_t dev, unsigned long near_ino, long vol, long
    vnode, long uniq, long datav);

int afs_syscall_ireadwrite(dev_t dev, unsigned long ino, long vol,
    long offset, unsigned char *buffaddr,
    unsigned long count, long rw);

int afs_syscall_iincdec(dev_t dev, unsigned long ino, long vol, long count);

#ifndef AFS_SERVER

int afs_syscall_iopen(dev_t dev, unsigned long ino, long mode)
{
	return ENOSYS;
}

int afs_syscall_icreate(dev_t dev, unsigned long near_ino, long vol, long
    vnode, long uniq, long datav)
{
	return ENOSYS;
}

int afs_syscall_ireadwrite(dev_t dev, unsigned long ino, long vol,
    long offset, unsigned char *buffaddr,
    unsigned long count, long rw)
{
	return ENOSYS;
}


int afs_syscall_iincdec(dev_t dev, unsigned long ino, long vol, long count)
{
	return ENOSYS;
}

#else

struct mount *
afs_istuff_getvfs(dev_t dev)
{
	struct mount *mp = ...;

	if (not FFS)
		return;
	
	fs = mp-> ...;
	if (not 4.4 inode format)
		return;
}

struct vnode *
afs_istuff_getvnode (dev_t dev, ino_t ino)
{
	
}


int
afs_syscall_iopen(dev_t dev, unsigned long ino, long mode)
{
	return ENOSYS;
}

/*
 * allocate a new inode, near dev/near_ino.
 * set magic frobs to vol/vnode/uniq/datav
 */
int afs_syscall_icreate(dev_t dev, unsigned long near_ino, long vol, long
    vnode, long uniq, long datav)
{
	struct mount *mp = afs_istuff_getvfs (dev);

	if (mp == NULL) {
		return ...;
	}
	
	if (not FFS)
		return;
	
	fs = mp-> ...;
	if (not 4.4 inode format)
		return;
	
	ffs_vget();
	
	ffs_valloc();

	set vicemagic, vicep1..p4;

	set refcount;

	vput();
	
	return inum;
}

int afs_syscall_ireadwrite(dev_t dev, unsigned long ino, long vol,
    long offset, unsigned char *buffaddr,
    unsigned long count, long rw)
{

	return ENOSYS;
}


int afs_syscall_iincdec(dev_t dev, unsigned long ino, long vol, long count)
{
	return ENOSYS;
}

#endif

#endif
